using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Xml;

namespace GMDL
{
    public partial class VectorGeo : Form
    {
        public VectorGeo()
        {
            InitializeComponent();
        }

        public void StatCanToV()
        {
            DirectoryInfo dest_dir = new DirectoryInfo(StatCanDir.Text + "\\statcan_rnf_v");
            if (dest_dir.Exists)
            {
                MessageBox.Show("statcan_rnf_v is already there");
            }
            else
            {
                dest_dir.Create();
                int tot_gml = 0;
                foreach (FileInfo gml_file in new DirectoryInfo(StatCanDir.Text).GetFiles("*.gml"))
                {
                    tot_gml++;
                }
                int this_gml = 0;
                foreach (FileInfo gml_file in new DirectoryInfo(StatCanDir.Text).GetFiles("*.gml"))
                {
                    this_gml++;
                    StatCanProgress.Text = "On " + this_gml.ToString() + " of " + tot_gml.ToString() + " " + gml_file.Name + " (loading)";
                    Application.DoEvents();

                    XmlDocument xd = new XmlDocument();
                    xd.Load(gml_file.FullName);

                    StatCanProgress.Text = "On " + this_gml.ToString() + " of " + tot_gml.ToString() + " " + gml_file.Name + " (processing)";
                    Application.DoEvents();

                    foreach (XmlNode res in xd.GetElementsByTagName("RoadSegment"))
                    {
                        string name = "";
                        string type = "";
                        string coordinates = "";

                        int nLf = 0;
                        int nLt = 0;
                        int nRf = 0;
                        int nRt = 0;

                        foreach (XmlNode res2 in res.ChildNodes)
                        {
                            if (res2.Name == "name")
                                name = res2.InnerText;
                            if (res2.Name == "type")
                                type = res2.InnerText;

                            if (res2.Name == "addrFmLeft" && res2.InnerText != "")
                                nLf = Int32.Parse(res2.InnerText);
                            if (res2.Name == "addrToLeft" && res2.InnerText != "")
                                nLt = Int32.Parse(res2.InnerText);
                            if (res2.Name == "addrFmRght" && res2.InnerText != "")
                                nRf = Int32.Parse(res2.InnerText);
                            if (res2.Name == "addrToRght" && res2.InnerText != "")
                                nRt = Int32.Parse(res2.InnerText);

                            if (res2.Name == "centreline")
                                coordinates = res2.ChildNodes[0].ChildNodes[0].InnerText.Trim() + " ";
                        }

                        int temp;

                        if (nLf > nLt)
                        {
                            temp = nLf;
                            nLf = nLt;
                            nLt = temp;
                        }
                        if (nRf > nRt)
                        {
                            temp = nRf;
                            nRf = nRt;
                            nRt = temp;
                        }

                        if (nLf == 0)
                            nLf = nLt;
                        if (nRf == 0)
                            nRf = nRt;

                        if (name != "")
                        {
                            name = (name + " " + type).ToUpper().Trim();

                            string numbersL = "";
                            if (nLf == nLt)
                                numbersL = nLf.ToString();
                            else
                                numbersL = nLf.ToString() + ";" + nLt.ToString();
                            string numbersR = "";
                            if (nRf == nRt)
                                numbersR = nRf.ToString();
                            else
                                numbersR = nRf.ToString() + ";" + nRt.ToString();
                            
                            //decimal lon = Decimal.Parse(coordinates.Substring(0, coordinates.IndexOf(",")), NumberFormatInfo.InvariantInfo);
                            //decimal lat = Decimal.Parse(coordinates.Substring(coordinates.IndexOf(",") + 1, coordinates.IndexOf(" ") - 1 - coordinates.IndexOf(",")), NumberFormatInfo.InvariantInfo);

							// -68.31859745193796,70.51391980133221 -68.31829796708777,70.51323715545631 -68.31464593937204,70.51161828077113 -68.31161176848605,70.5107997868952 -68.30384466876049,70.50938936728926 -68.30150142622105,70.50880642068631 -68.29973447334554,70.50805132254374 <

							int start = 0;
							int end = coordinates.IndexOf(" ");
							while (end != -1)
							{
                                decimal lon = Decimal.Parse(coordinates.Substring(start, coordinates.IndexOf(",", start)));
                                decimal lat = Decimal.Parse(coordinates.Substring(coordinates.IndexOf(",", start), end));

                                decimal[] xy = getXYdec(lon, lat, 5);
								int x = System.Convert.ToInt32(System.Decimal.Truncate((decimal)xy[0]));
                                int y = System.Convert.ToInt32(System.Decimal.Truncate((decimal)xy[1]));
								
							
// (rounded) - write to segment
								
								start = end + 1;
								end = coordinates.IndexOf(" ", start);
							}
                        }
                    }
                }
             
// compress segments

// del temp?

                StatCanProgress.Text = "";
MessageBox.Show("Done, ...");
            }
        }

        // this seems to round wrong (try? http://cfis.savagexi.com/articles/2006/05/03/google-maps-deconstructed)
        private decimal[] getXYdec(decimal lat, decimal lon, decimal zoom)
        {
            #region borrowed code

            decimal bc = (decimal)6.28318530717958652866;
            decimal Wa = (decimal)0.017453292519943295912944444444444;

            decimal c = 256;
            decimal d = 17;

            decimal pixelsPerLonDegree = 0;
            decimal pixelsPerLonRadian = 0;
            decimal bitmapOrigo = 0;

            while (d >= zoom)
            {
                d = d - 1;
                pixelsPerLonDegree = c / 360;
                pixelsPerLonRadian = c / bc;
                bitmapOrigo = c / 2;
                c = c * 2;
            }

            decimal x = (bitmapOrigo + lon * pixelsPerLonDegree) / 256;
            decimal e = (decimal)Math.Sin(System.Convert.ToDouble(lat * Wa));
            decimal y = (bitmapOrigo + (decimal)0.5 * (decimal)Math.Log(System.Convert.ToDouble((1 + (e)) / (1 - (e)))) * -1 * pixelsPerLonRadian) / 256;
            #endregion

            return new decimal[] { x, y };
        }

        private void StatCanSetDir_Click(object sender, EventArgs e)
        {
            string dir = System.IO.Directory.GetCurrentDirectory();

            FolderBrowserDialog file = new FolderBrowserDialog();
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.SelectedPath != "")
            {
                StatCanDir.Text = file.SelectedPath;
            }
        }
    }
}